// =============================================================================
// a Sample application Case of unconstrained optimizatoin library.
// programmer: A. Katanforoush,
// last update: 7/2/2003,
// =============================================================================
//
// Comparison different optimization methods by the test problem. 
//
// =============================================================================

#include <stdio.h>
#include "SampleCase.h"

int main() {
	// Rosenbrock r(3);
	Powell r(3);
	int opt;

	opt=r.DFPoptimize();
	printf("DFP:   x1 = %-0.10lg   x2 = %-0.10lg   F = %-0.10lg\n", r.x[0], r.x[1], r.f);
	printf("     cnls = %i   cnf = %i   cng = %i   optimality = %i\n\n", r.cnls, r.cnf, r.cng, opt);

	r.x[0]=3;
	r.x[1]=-1;
	r.x[2]=0;
	r.x[3]=1;
	opt=r.BFGSoptimize();
	printf("BFGS:  x1 = %-0.10lg   x2 = %-0.10lg   F = %-0.10lg\n", r.x[0], r.x[1], r.f);
	printf("     cnls = %i   cnf = %i   cng = %i   optimality = %i\n\n", r.cnls, r.cnf, r.cng, opt);

	r.x[0]=3;
	r.x[1]=-1;
	r.x[2]=0;
	r.x[3]=1;
	opt=r.FRoptimize(0);
	printf("FR:    x1 = %-0.10lg   x2 = %-0.10lg   F = %-0.10lg\n", r.x[0], r.x[1], r.f);
	printf("     cnls = %i   cnf = %i   cng = %i   optimality = %i\n\n", r.cnls, r.cnf, r.cng, opt);

	r.x[0]=3;
	r.x[1]=-1;
	r.x[2]=0;
	r.x[3]=1;
	opt=r.FRoptimize(1);
	printf("FR:    x1 = %-0.10lg   x2 = %-0.10lg   F = %-0.10lg\n", r.x[0], r.x[1], r.f);
	printf("     cnls = %i   cnf = %i   cng = %i   optimality = %i\n\n", r.cnls, r.cnf, r.cng, opt);

	r.x[0]=3;
	r.x[1]=-1;
	r.x[2]=0;
	r.x[3]=1;
	opt=r.PRoptimize(0);
	printf("PR:    x1 = %-0.10lg   x2 = %-0.10lg   F = %-0.10lg\n", r.x[0], r.x[1], r.f);
	printf("     cnls = %i   cnf = %i   cng = %i   optimality = %i\n\n", r.cnls, r.cnf, r.cng, opt);

	r.x[0]=3;
	r.x[1]=-1;
	r.x[2]=0;
	r.x[3]=1;
	opt=r.PRoptimize(1);
	printf("PR:    x1 = %-0.10lg   x2 = %-0.10lg   F = %-0.10lg\n", r.x[0], r.x[1], r.f);
	printf("     cnls = %i   cnf = %i   cng = %i   optimality = %i\n\n", r.cnls, r.cnf, r.cng, opt);

	getchar();

	return 0;
}

