// =============================================================================
// a Sample application Case of unconstrained optimizatoin library.
// programmer: A. Katanforoush,
// last update: 7/2/2003,
// =============================================================================
//
// Write a suit constructor then override F() and G() in derived class.
//
// I have provided two famous test problem for unconstrained optimization as sample cases.
// Rosenbrock: F(x) = 100 ( x^2 - y )^2 + ( 1 - x )^2
// Powell: F(x) = (x+10y)^2 + 5(z-w)^2 + (y-2*z)^4 + 10(x-w)^4
// =============================================================================

#ifndef SAMPLECASE_H
#define SAMPLECASE_H

#include "uncoptim.h"

class Rosenbrock: public UnconstrainedOptim {
public:
		Rosenbrock(int lsmethod):UnconstrainedOptim(2,0,0,lsmethod) {
				x[0]=-1.2;
				x[1]=1;
		}
		void F() {
				double w1=x[1]-x[0]*x[0];
				double w2=1-x[0];
				f=100*w1*w1+w2*w2;
		}
		void G() {
				g[1]=200*(x[1]-x[0]*x[0]);
				g[0]=-2*(x[0]*g[1]+1-x[0]);
		}
};

class Powell: public UnconstrainedOptim {
public:
		Powell(int lsmethod):UnconstrainedOptim(4,0,0,lsmethod) {
				x[0]=3;
				x[1]=-1;
				x[2]=0;
				x[3]=1;
		}
		void F() {
				double w1=x[0]+10*x[1];
				double w2=x[2]-x[3];
				double w3=x[1]-2*x[2]; w3*=w3;
				double w4=x[0]-x[3]; w4*=w4;
				f=w1*w1+5*w2*w2+w3*w3+10*w4*w4;
		}
    void G() {
        double x5=x[0]+10*x[1];
        double x6=x[2]-x[3];
        double x7=x[0]-x[3];	x7=x7*x7*x7;
        double x8=x[1]-2*x[2];	x8=x8*x8*x8;
        g[0]=2*x5+40*x7;
        g[1]=20*x5+4*x8;
        g[2]=10*x6-8*x8;
        g[3]=-10*x6-40*x7;
    }
};

#endif

